> ## Documentation Index
> Fetch the complete documentation index at: https://docs.seam.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a Thermostat Daily Program

> Updates a specified thermostat daily program. The periods that you specify overwrite any existing periods for the daily program.



## OpenAPI

````yaml /openapi.json post /thermostats/daily_programs/update
openapi: 3.0.0
info:
  title: Seam Connect
  version: 1.0.0
servers:
  - url: https://connect.getseam.com
security: []
tags:
  - description: access_codes
    name: /access_codes
  - description: acs
    name: /acs
  - description: action_attempts
    name: /action_attempts
  - description: client_sessions
    name: /client_sessions
  - description: connected_accounts
    name: /connected_accounts
  - description: connect_webviews
    name: /connect_webviews
  - description: devices
    name: /devices
  - description: events
    name: /events
  - description: health
    name: /health
  - description: locks
    name: /locks
  - description: networks
    name: /networks
  - description: noise_sensors
    name: /noise_sensors
  - description: phones
    name: /phones
  - description: thermostats
    name: /thermostats
  - description: user_identities
    name: /user_identities
  - description: webhooks
    name: /webhooks
  - description: workspaces
    name: /workspaces
paths:
  /thermostats/daily_programs/update:
    post:
      tags:
        - /thermostats
      summary: Update a Thermostat Daily Program
      description: >-
        Updates a specified thermostat daily program. The periods that you
        specify overwrite any existing periods for the daily program.
      operationId: thermostatsDailyProgramsUpdatePost
      requestBody:
        content:
          application/json:
            schema:
              properties:
                name:
                  description: >-
                    Name of the thermostat daily program that you want to
                    update.
                  type: string
                periods:
                  description: >-
                    Array of thermostat daily program periods. The periods that
                    you specify overwrite any existing periods for the daily
                    program.
                  items:
                    description: >-
                      Period for a thermostat daily program. Consists of a
                      starts at time and the key that identifies the configured
                      climate preset to apply at the starting time.
                    properties:
                      climate_preset_key:
                        description: >-
                          Key of the [climate
                          preset](https://docs.seam.co/capability-guides/thermostats/creating-and-managing-climate-presets)
                          to activate at the `starts_at_time`.
                        type: string
                      starts_at_time:
                        description: >-
                          Time at which the thermostat daily program period
                          starts, in [ISO
                          8601](https://www.iso.org/iso-8601-date-and-time-format.html)
                          format.
                        pattern: ^([01]\d|2[0-3]):([0-5]\d):([0-5]\d)$
                        type: string
                    required:
                      - starts_at_time
                      - climate_preset_key
                    type: object
                  type: array
                thermostat_daily_program_id:
                  description: ID of the thermostat daily program that you want to update.
                  format: uuid
                  type: string
              required:
                - thermostat_daily_program_id
                - name
                - periods
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  action_attempt:
                    type: object
                    description: >-
                      Tracks the progress of this operation. Poll using the
                      action_attempt_id.
                    properties:
                      action_attempt_id:
                        type: string
                        format: uuid
                        description: ID of the action attempt.
                      action_type:
                        type: string
                        enum:
                          - PUSH_THERMOSTAT_PROGRAMS
                        description: Type of action being tracked.
                      status:
                        type: string
                        enum:
                          - pending
                          - success
                          - error
                        description: Current status of the action.
                      result:
                        type: object
                        nullable: true
                        description: Result payload on success.
                      error:
                        type: object
                        nullable: true
                        description: Error details on failure.
                        properties:
                          type:
                            type: string
                          message:
                            type: string
                    required:
                      - action_attempt_id
                      - action_type
                      - status
                  ok:
                    type: boolean
                required:
                  - action_attempt
                  - ok
                type: object
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
      security:
        - client_session: []
        - pat_with_workspace: []
        - console_session_with_workspace: []
        - api_key: []
      x-codeSamples:
        - lang: javascript
          label: Seam SDK
          source: |-
            await seam.thermostats.dailyPrograms.update({
              thermostat_daily_program_id: "6baf3a53-ba83-4052-8ea5-143584e18f03",
              name: "Weekday Program",
              periods: [
                { starts_at_time: "07:00:00", climate_preset_key: "Home" },
                { starts_at_time: "09:00:00", climate_preset_key: "Away" },
                { starts_at_time: "17:00:00", climate_preset_key: "Home" },
                { starts_at_time: "22:30:00", climate_preset_key: "Sleep" },
              ],
            });

            /*
            {
              "action_attempt_id": "a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",
              "action_type": "PUSH_THERMOSTAT_PROGRAMS",
              "error": null,
              "result": {},
              "status": "success"
            }
            */
        - lang: bash
          label: cURL
          source: >-
            curl --include --request POST
            "https://connect.getseam.com/thermostats/daily_programs/update" \
              --header "Authorization: Bearer $SEAM_API_KEY" \
              --json @- <<EOF
            {
              "thermostat_daily_program_id": "6baf3a53-ba83-4052-8ea5-143584e18f03",
              "name": "Weekday Program",
              "periods": [
                {
                  "starts_at_time": "07:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "09:00:00",
                  "climate_preset_key": "Away"
                },
                {
                  "starts_at_time": "17:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "22:30:00",
                  "climate_preset_key": "Sleep"
                }
              ]
            }

            EOF


            # Response:

            # {

            #   "action_attempt": {

            #     "action_attempt_id": "a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",

            #     "action_type": "PUSH_THERMOSTAT_PROGRAMS",

            #     "error": null,

            #     "result": {},

            #     "status": "success"

            #   }

            # }
        - lang: python
          label: Seam SDK
          source: |-
            seam.thermostats.daily_programs.update(
                thermostat_daily_program_id="6baf3a53-ba83-4052-8ea5-143584e18f03",
                name="Weekday Program",
                periods=[
                    {"starts_at_time": "07:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "09:00:00", "climate_preset_key": "Away"},
                    {"starts_at_time": "17:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "22:30:00", "climate_preset_key": "Sleep"},
                ],
            )

            # ActionAttempt(
                action_attempt_id="a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",
                action_type="PUSH_THERMOSTAT_PROGRAMS",
                error=None,
                result={},
                status="success",
            )
        - lang: ruby
          label: Seam SDK
          source: |-
            seam.thermostats.daily_programs.update(
              thermostat_daily_program_id: "6baf3a53-ba83-4052-8ea5-143584e18f03",
              name: "Weekday Program",
              periods: [
                { starts_at_time: "07:00:00", climate_preset_key: "Home" },
                { starts_at_time: "09:00:00", climate_preset_key: "Away" },
                { starts_at_time: "17:00:00", climate_preset_key: "Home" },
                { starts_at_time: "22:30:00", climate_preset_key: "Sleep" },
              ],
            )

            # => {
              "action_attempt_id" => "a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",
              "action_type" => "PUSH_THERMOSTAT_PROGRAMS",
              "error" => nil,
              "result" => {
              },
              "status" => "success",
            }
        - lang: php
          label: Seam SDK
          source: |-
            $seam->thermostats->daily_programs->update(
                thermostat_daily_program_id: "6baf3a53-ba83-4052-8ea5-143584e18f03",
                name: "Weekday Program",
                periods: [
                    ["starts_at_time" => "07:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "09:00:00", "climate_preset_key" => "Away"],
                    ["starts_at_time" => "17:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "22:30:00", "climate_preset_key" => "Sleep"],
                ],
            );

            // [
                "action_attempt_id" => "a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",
                "action_type" => "PUSH_THERMOSTAT_PROGRAMS",
                "error" => null,
                "result" => [],
                "status" => "success",
            ];
        - lang: bash
          label: Seam CLI
          source: >-
            seam thermostats daily-programs update --thermostat_daily_program_id
            "6baf3a53-ba83-4052-8ea5-143584e18f03" --name "Weekday Program"
            --periods
            [{"starts_at_time":"07:00:00","climate_preset_key":"Home"},{"starts_at_time":"09:00:00","climate_preset_key":"Away"},{"starts_at_time":"17:00:00","climate_preset_key":"Home"},{"starts_at_time":"22:30:00","climate_preset_key":"Sleep"}]


            # {

            #   "action_attempt_id": "a1b2c3d4-e5f6-4a3b-2c1d-0e9f8a7b6c5d",

            #   "action_type": "PUSH_THERMOSTAT_PROGRAMS",

            #   "error": null,

            #   "result": {},

            #   "status": "success"

            # }
components:
  securitySchemes:
    client_session:
      bearerFormat: Client Session Token
      scheme: bearer
      type: http
    pat_with_workspace:
      bearerFormat: API Token
      scheme: bearer
      type: http
    console_session_with_workspace:
      bearerFormat: Console Session Token
      scheme: bearer
      type: http
    api_key:
      bearerFormat: API Key
      scheme: bearer
      type: http

````